package com.ab.abmeter;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = true;
	private static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.ab.abmeter", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "com.ab.abmeter", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _title = "";
public com.AB.ABExtDrawing.ABExtDrawing.ABRectF _rimrect = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _rimpaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _rimcirclepaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABRectF _facerect = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _facetexture = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _facepaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _rimshadowpaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _scalepaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABRectF _scalerect = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _titlepaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPath _titlepath = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _logopaint = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _logo = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABMatrix _logomatrix = null;
public static double _logoscale = 0;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _handpaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPath _handpath = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _handscrewpaint = null;
public com.AB.ABExtDrawing.ABExtDrawing.ABPaint _backgroundpaint = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _background = null;
public com.AB.ABExtDrawing.ABExtDrawing _exdraw = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _mycanvas = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public static int _totalnicks = 0;
public static double _degreespernick = 0;
public static int _centerdegree = 0;
public static int _mindegrees = 0;
public static int _maxdegrees = 0;
public static boolean _handinitialized = false;
public static double _handposition = 0;
public static double _handtarget = 0;
public static double _handvelocity = 0;
public static double _handacceleration = 0;
public static long _lasthandmovetime = 0L;
public anywheresoftware.b4a.phone.Phone.PhoneSensors _pstemp = null;
public anywheresoftware.b4a.phone.Phone.PhoneSensors _psfaketemp = null;
public static boolean _tempisfaked = false;
public static float _scale = 0f;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 75;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 76;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 77;BA.debugLine="Activity.LoadLayout(\"2\")";
mostCurrent._activity.LoadLayout("2",mostCurrent.activityBA);
 //BA.debugLineNum = 78;BA.debugLine="MyCanvas.Initialize(Panel1)";
mostCurrent._mycanvas.Initialize((android.view.View)(mostCurrent._panel1.getObject()));
 //BA.debugLineNum = 79;BA.debugLine="psTemp.Initialize(psTemp.TYPE_TEMPERATURE)";
mostCurrent._pstemp.Initialize(mostCurrent._pstemp.TYPE_TEMPERATURE);
 //BA.debugLineNum = 80;BA.debugLine="psFakeTemp.Initialize(psFakeTemp.TYPE_MAGNETIC_FIELD)";
mostCurrent._psfaketemp.Initialize(mostCurrent._psfaketemp.TYPE_MAGNETIC_FIELD);
 };
 //BA.debugLineNum = 83;BA.debugLine="scale = Activity.Width";
_scale = (float)(mostCurrent._activity.getWidth());
 //BA.debugLineNum = 85;BA.debugLine="InitDrawingTools";
_initdrawingtools();
 //BA.debugLineNum = 87;BA.debugLine="GenerateBackground";
_generatebackground();
 //BA.debugLineNum = 88;BA.debugLine="drawMe(MyCanvas)";
_drawme(mostCurrent._mycanvas);
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 99;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 100;BA.debugLine="If TempIsFaked Then";
if (_tempisfaked) { 
 //BA.debugLineNum = 101;BA.debugLine="psFakeTemp.StopListening";
mostCurrent._psfaketemp.StopListening(processBA);
 }else {
 //BA.debugLineNum = 103;BA.debugLine="psTemp.StopListening";
mostCurrent._pstemp.StopListening(processBA);
 };
 //BA.debugLineNum = 105;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 91;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 92;BA.debugLine="If psTemp.StartListening(\"Sensor\") = False Then";
if (mostCurrent._pstemp.StartListening(processBA,"Sensor")==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 94;BA.debugLine="TempIsFaked = True";
_tempisfaked = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 95;BA.debugLine="psFakeTemp.StartListening(\"sensor\")";
mostCurrent._psfaketemp.StartListening(processBA,"sensor");
 };
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return "";
}
public static String  _degreetoangle(float _degree) throws Exception{
 //BA.debugLineNum = 281;BA.debugLine="Sub degreeToAngle(degree As Float)";
 //BA.debugLineNum = 282;BA.debugLine="Return (degree - centerDegree) / 2.0 * degreesPerNick";
if (true) return BA.NumberToString((_degree-_centerdegree)/(double)2.0*_degreespernick);
 //BA.debugLineNum = 283;BA.debugLine="End Sub";
return "";
}
public static String  _drawbackground(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
 //BA.debugLineNum = 330;BA.debugLine="Sub drawBackground(Canv As Canvas)";
 //BA.debugLineNum = 331;BA.debugLine="If background <> Null Then";
if (mostCurrent._background!= null) { 
 //BA.debugLineNum = 332;BA.debugLine="ExDraw.drawBitmap2(Canv, background, 0,0, backgroundPaint)";
mostCurrent._exdraw.drawBitmap2(_canv,(android.graphics.Bitmap)(mostCurrent._background.getObject()),(float)(0),(float)(0),mostCurrent._backgroundpaint);
 };
 //BA.debugLineNum = 334;BA.debugLine="End Sub";
return "";
}
public static String  _drawface(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
 //BA.debugLineNum = 231;BA.debugLine="Sub drawFace(Canv As Canvas)";
 //BA.debugLineNum = 232;BA.debugLine="ExDraw.drawOval(Canv, faceRect, facePaint)";
mostCurrent._exdraw.drawOval(_canv,mostCurrent._facerect,mostCurrent._facepaint);
 //BA.debugLineNum = 234;BA.debugLine="ExDraw.drawOval(Canv, faceRect, rimCirclePaint)";
mostCurrent._exdraw.drawOval(_canv,mostCurrent._facerect,mostCurrent._rimcirclepaint);
 //BA.debugLineNum = 236;BA.debugLine="ExDraw.drawOval(Canv, faceRect, rimShadowPaint)";
mostCurrent._exdraw.drawOval(_canv,mostCurrent._facerect,mostCurrent._rimshadowpaint);
 //BA.debugLineNum = 237;BA.debugLine="End Sub";
return "";
}
public static String  _drawhand(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
float _handangle = 0f;
 //BA.debugLineNum = 317;BA.debugLine="Sub drawHand(Canv As Canvas)";
 //BA.debugLineNum = 318;BA.debugLine="If handInitialized Then";
if (_handinitialized) { 
 //BA.debugLineNum = 319;BA.debugLine="Dim handAngle As Float";
_handangle = 0f;
 //BA.debugLineNum = 320;BA.debugLine="handAngle = degreeToAngle(handPosition)";
_handangle = (float)(Double.parseDouble(_degreetoangle((float)(_handposition))));
 //BA.debugLineNum = 321;BA.debugLine="ExDraw.save2(Canv, ExDraw.MATRIX_SAVE_FLAG)";
mostCurrent._exdraw.save2(_canv,mostCurrent._exdraw.MATRIX_SAVE_FLAG);
 //BA.debugLineNum = 322;BA.debugLine="ExDraw.rotate2(Canv, handAngle, 0.5, 0.5)";
mostCurrent._exdraw.rotate2(_canv,_handangle,(float)(0.5),(float)(0.5));
 //BA.debugLineNum = 323;BA.debugLine="ExDraw.drawPath(Canv, handPath, handPaint)";
mostCurrent._exdraw.drawPath(_canv,mostCurrent._handpath,mostCurrent._handpaint);
 //BA.debugLineNum = 324;BA.debugLine="ExDraw.restore(Canv)";
mostCurrent._exdraw.restore(_canv);
 //BA.debugLineNum = 326;BA.debugLine="ExDraw.drawCircle(Canv,0.5, 0.5, 0.01, handScrewPaint)";
mostCurrent._exdraw.drawCircle(_canv,(float)(0.5),(float)(0.5),(float)(0.01),mostCurrent._handscrewpaint);
 };
 //BA.debugLineNum = 328;BA.debugLine="End Sub";
return "";
}
public static String  _drawlogo(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
int _color = 0;
float _position = 0f;
 //BA.debugLineNum = 289;BA.debugLine="Sub drawLogo(Canv As Canvas)";
 //BA.debugLineNum = 290;BA.debugLine="ExDraw.save2(Canv, ExDraw.MATRIX_SAVE_FLAG)";
mostCurrent._exdraw.save2(_canv,mostCurrent._exdraw.MATRIX_SAVE_FLAG);
 //BA.debugLineNum = 291;BA.debugLine="ExDraw.translate(Canv, 0.5 - logo.Width * logoScale / 2.0, 0.5 - logo.Height * logoScale / 2.0)";
mostCurrent._exdraw.translate(_canv,(float)(0.5-mostCurrent._logo.getWidth()*_logoscale/(double)2.0),(float)(0.5-mostCurrent._logo.getHeight()*_logoscale/(double)2.0));
 //BA.debugLineNum = 293;BA.debugLine="Dim color As Int";
_color = 0;
 //BA.debugLineNum = 295;BA.debugLine="Dim position As Float";
_position = 0f;
 //BA.debugLineNum = 296;BA.debugLine="position = getRelativeTemperaturePosition";
_position = _getrelativetemperatureposition();
 //BA.debugLineNum = 297;BA.debugLine="If (position < 0) Then";
if ((_position<0)) { 
 //BA.debugLineNum = 298;BA.debugLine="color = Bit.Or(color,(240 * -position)) ' blue";
_color = anywheresoftware.b4a.keywords.Common.Bit.Or(_color,(int)((240*-_position)));
 }else {
 //BA.debugLineNum = 300;BA.debugLine="color = Bit.Or(color,Bit.ShiftLeft((240 * position), 16))' red";
_color = anywheresoftware.b4a.keywords.Common.Bit.Or(_color,anywheresoftware.b4a.keywords.Common.Bit.ShiftLeft((int)((240*_position)),(int)(16)));
 };
 //BA.debugLineNum = 303;BA.debugLine="logoPaint.SetLightingColorFilter(4281567266, color)";
mostCurrent._logopaint.SetLightingColorFilter((int)(4281567266L),_color);
 //BA.debugLineNum = 305;BA.debugLine="ExDraw.drawBitmap4(Canv, logo, logoMatrix, logoPaint)";
mostCurrent._exdraw.drawBitmap4(_canv,(android.graphics.Bitmap)(mostCurrent._logo.getObject()),mostCurrent._logomatrix,mostCurrent._logopaint);
 //BA.debugLineNum = 306;BA.debugLine="ExDraw.restore(Canv)";
mostCurrent._exdraw.restore(_canv);
 //BA.debugLineNum = 307;BA.debugLine="End Sub";
return "";
}
public static String  _drawme(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
 //BA.debugLineNum = 336;BA.debugLine="Sub drawMe(Canv As Canvas)";
 //BA.debugLineNum = 337;BA.debugLine="drawBackground(Canv)";
_drawbackground(_canv);
 //BA.debugLineNum = 339;BA.debugLine="ExDraw.save2(Canv, ExDraw.MATRIX_SAVE_FLAG)";
mostCurrent._exdraw.save2(_canv,mostCurrent._exdraw.MATRIX_SAVE_FLAG);
 //BA.debugLineNum = 340;BA.debugLine="ExDraw.scale(Canv, scale, scale)";
mostCurrent._exdraw.scale(_canv,_scale,_scale);
 //BA.debugLineNum = 342;BA.debugLine="drawLogo(Canv)";
_drawlogo(_canv);
 //BA.debugLineNum = 343;BA.debugLine="drawHand(Canv)";
_drawhand(_canv);
 //BA.debugLineNum = 345;BA.debugLine="ExDraw.restore(Canv)";
mostCurrent._exdraw.restore(_canv);
 //BA.debugLineNum = 347;BA.debugLine="If handNeedsToMove Then";
if (_handneedstomove()) { 
 //BA.debugLineNum = 348;BA.debugLine="MoveHand";
_movehand();
 };
 //BA.debugLineNum = 351;BA.debugLine="Panel1.Invalidate";
mostCurrent._panel1.Invalidate();
 //BA.debugLineNum = 352;BA.debugLine="End Sub";
return "";
}
public static String  _drawrim(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
 //BA.debugLineNum = 224;BA.debugLine="Sub drawRim(Canv As Canvas)";
 //BA.debugLineNum = 226;BA.debugLine="ExDraw.drawOval(Canv, rimRect, rimPaint)";
mostCurrent._exdraw.drawOval(_canv,mostCurrent._rimrect,mostCurrent._rimpaint);
 //BA.debugLineNum = 228;BA.debugLine="ExDraw.drawOval(Canv, rimRect, rimCirclePaint)";
mostCurrent._exdraw.drawOval(_canv,mostCurrent._rimrect,mostCurrent._rimcirclepaint);
 //BA.debugLineNum = 229;BA.debugLine="End Sub";
return "";
}
public static String  _drawscale(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
int _i = 0;
float _y1 = 0f;
float _y2 = 0f;
int _value = 0;
String _valuestring = "";
 //BA.debugLineNum = 239;BA.debugLine="Sub drawScale(Canv As Canvas)";
 //BA.debugLineNum = 240;BA.debugLine="ExDraw.drawOval(Canv, scaleRect, ScalePaint)";
mostCurrent._exdraw.drawOval(_canv,mostCurrent._scalerect,mostCurrent._scalepaint);
 //BA.debugLineNum = 242;BA.debugLine="ExDraw.save2(Canv, ExDraw.MATRIX_SAVE_FLAG)";
mostCurrent._exdraw.save2(_canv,mostCurrent._exdraw.MATRIX_SAVE_FLAG);
 //BA.debugLineNum = 243;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 244;BA.debugLine="Dim y1 As Float";
_y1 = 0f;
 //BA.debugLineNum = 245;BA.debugLine="Dim y2 As Float";
_y2 = 0f;
 //BA.debugLineNum = 246;BA.debugLine="Dim value As Int";
_value = 0;
 //BA.debugLineNum = 247;BA.debugLine="Dim valueString As String";
_valuestring = "";
 //BA.debugLineNum = 248;BA.debugLine="For i = 0 To totalNicks";
{
final double step188 = 1;
final double limit188 = _totalnicks;
for (_i = (int)(0); (step188 > 0 && _i <= limit188) || (step188 < 0 && _i >= limit188); _i += step188) {
 //BA.debugLineNum = 249;BA.debugLine="y1 = scaleRect.top";
_y1 = mostCurrent._scalerect.getTop();
 //BA.debugLineNum = 250;BA.debugLine="y2 = y1 - 0.020";
_y2 = (float)(_y1-0.020);
 //BA.debugLineNum = 252;BA.debugLine="ExDraw.drawLine(Canv, 0.5, y1, 0.5, y2, ScalePaint)";
mostCurrent._exdraw.drawLine(_canv,(float)(0.5),_y1,(float)(0.5),_y2,mostCurrent._scalepaint);
 //BA.debugLineNum = 254;BA.debugLine="If (i Mod 5 = 0) Then";
if ((_i%5==0)) { 
 //BA.debugLineNum = 255;BA.debugLine="value = nickToDegree(i)";
_value = _nicktodegree(_i);
 //BA.debugLineNum = 256;BA.debugLine="If (value >= minDegrees AND value <= maxDegrees) Then";
if ((_value>=_mindegrees && _value<=_maxdegrees)) { 
 //BA.debugLineNum = 257;BA.debugLine="valueString = value";
_valuestring = BA.NumberToString(_value);
 //BA.debugLineNum = 258;BA.debugLine="ExDraw.drawText(Canv, valueString, 0.5, y2 - 0.015, ScalePaint)";
mostCurrent._exdraw.drawText(_canv,_valuestring,(float)(0.5),(float)(_y2-0.015),mostCurrent._scalepaint);
 };
 };
 //BA.debugLineNum = 262;BA.debugLine="ExDraw.rotate2(Canv, degreesPerNick, 0.5, 0.5)";
mostCurrent._exdraw.rotate2(_canv,(float)(_degreespernick),(float)(0.5),(float)(0.5));
 }
};
 //BA.debugLineNum = 264;BA.debugLine="ExDraw.restore(Canv)";
mostCurrent._exdraw.restore(_canv);
 //BA.debugLineNum = 265;BA.debugLine="End Sub";
return "";
}
public static String  _drawtitle(anywheresoftware.b4a.objects.drawable.CanvasWrapper _canv) throws Exception{
 //BA.debugLineNum = 285;BA.debugLine="Sub drawTitle(Canv As Canvas)";
 //BA.debugLineNum = 286;BA.debugLine="ExDraw.drawTextOnPath(Canv, Title, titlePath, 0.0, 0.0, titlePaint)";
mostCurrent._exdraw.drawTextOnPath(_canv,_title,mostCurrent._titlepath,(float)(0.0),(float)(0.0),mostCurrent._titlepaint);
 //BA.debugLineNum = 287;BA.debugLine="End Sub";
return "";
}
public static String  _generatebackground() throws Exception{
anywheresoftware.b4a.objects.drawable.CanvasWrapper _backgroundcanvas = null;
 //BA.debugLineNum = 116;BA.debugLine="Sub GenerateBackground()";
 //BA.debugLineNum = 117;BA.debugLine="background.InitializeMutable(Activity.Width, Activity.Height)";
mostCurrent._background.InitializeMutable(mostCurrent._activity.getWidth(),mostCurrent._activity.getHeight());
 //BA.debugLineNum = 118;BA.debugLine="Dim backgroundCanvas As Canvas";
_backgroundcanvas = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 119;BA.debugLine="backgroundCanvas.Initialize2(background)";
_backgroundcanvas.Initialize2((android.graphics.Bitmap)(mostCurrent._background.getObject()));
 //BA.debugLineNum = 121;BA.debugLine="ExDraw.scale(backgroundCanvas, scale, scale)";
mostCurrent._exdraw.scale(_backgroundcanvas,_scale,_scale);
 //BA.debugLineNum = 123;BA.debugLine="drawRim(backgroundCanvas)";
_drawrim(_backgroundcanvas);
 //BA.debugLineNum = 124;BA.debugLine="drawFace(backgroundCanvas)";
_drawface(_backgroundcanvas);
 //BA.debugLineNum = 125;BA.debugLine="drawScale(backgroundCanvas)";
_drawscale(_backgroundcanvas);
 //BA.debugLineNum = 126;BA.debugLine="drawTitle(backgroundCanvas)";
_drawtitle(_backgroundcanvas);
 //BA.debugLineNum = 127;BA.debugLine="End Sub";
return "";
}
public static float  _getrelativetemperatureposition() throws Exception{
 //BA.debugLineNum = 309;BA.debugLine="Sub getRelativeTemperaturePosition() As Float";
 //BA.debugLineNum = 310;BA.debugLine="If (handPosition < centerDegree) Then";
if ((_handposition<_centerdegree)) { 
 //BA.debugLineNum = 311;BA.debugLine="Return - (centerDegree - handPosition) / (centerDegree - minDegrees)";
if (true) return (float)(-(_centerdegree-_handposition)/(double)(_centerdegree-_mindegrees));
 }else {
 //BA.debugLineNum = 313;BA.debugLine="Return (handPosition - centerDegree) / (maxDegrees - centerDegree)";
if (true) return (float)((_handposition-_centerdegree)/(double)(_maxdegrees-_centerdegree));
 };
 //BA.debugLineNum = 315;BA.debugLine="End Sub";
return 0f;
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 10;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 13;BA.debugLine="Dim rimRect As ABRectF";
mostCurrent._rimrect = new com.AB.ABExtDrawing.ABExtDrawing.ABRectF();
 //BA.debugLineNum = 14;BA.debugLine="Dim rimPaint As ABPaint";
mostCurrent._rimpaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 15;BA.debugLine="Dim rimCirclePaint As ABPaint";
mostCurrent._rimcirclepaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 17;BA.debugLine="Dim faceRect As ABRectF";
mostCurrent._facerect = new com.AB.ABExtDrawing.ABExtDrawing.ABRectF();
 //BA.debugLineNum = 18;BA.debugLine="Dim faceTexture As Bitmap";
mostCurrent._facetexture = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 19;BA.debugLine="Dim facePaint As ABPaint";
mostCurrent._facepaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 20;BA.debugLine="Dim rimShadowPaint As ABPaint";
mostCurrent._rimshadowpaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 22;BA.debugLine="Dim ScalePaint As ABPaint";
mostCurrent._scalepaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 23;BA.debugLine="Dim scaleRect As ABRectF";
mostCurrent._scalerect = new com.AB.ABExtDrawing.ABExtDrawing.ABRectF();
 //BA.debugLineNum = 25;BA.debugLine="Dim titlePaint As ABPaint";
mostCurrent._titlepaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 26;BA.debugLine="Dim titlePath As ABPath";
mostCurrent._titlepath = new com.AB.ABExtDrawing.ABExtDrawing.ABPath();
 //BA.debugLineNum = 28;BA.debugLine="Dim logoPaint As ABPaint";
mostCurrent._logopaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 29;BA.debugLine="Dim logo As Bitmap";
mostCurrent._logo = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim logoMatrix As ABMatrix";
mostCurrent._logomatrix = new com.AB.ABExtDrawing.ABExtDrawing.ABMatrix();
 //BA.debugLineNum = 31;BA.debugLine="Dim logoScale As Double";
_logoscale = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim handPaint As ABPaint";
mostCurrent._handpaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 34;BA.debugLine="Dim handPath As ABPath";
mostCurrent._handpath = new com.AB.ABExtDrawing.ABExtDrawing.ABPath();
 //BA.debugLineNum = 35;BA.debugLine="Dim handScrewPaint As ABPaint";
mostCurrent._handscrewpaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 37;BA.debugLine="Dim backgroundPaint As ABPaint";
mostCurrent._backgroundpaint = new com.AB.ABExtDrawing.ABExtDrawing.ABPaint();
 //BA.debugLineNum = 38;BA.debugLine="Dim background As Bitmap";
mostCurrent._background = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim ExDraw As ABExtDrawing";
mostCurrent._exdraw = new com.AB.ABExtDrawing.ABExtDrawing();
 //BA.debugLineNum = 42;BA.debugLine="Dim MyCanvas As Canvas";
mostCurrent._mycanvas = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Dim Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Dim totalNicks As Int";
_totalnicks = 0;
 //BA.debugLineNum = 47;BA.debugLine="totalNicks = 100";
_totalnicks = (int)(100);
 //BA.debugLineNum = 48;BA.debugLine="Dim degreesPerNick As Double";
_degreespernick = 0;
 //BA.debugLineNum = 49;BA.debugLine="degreesPerNick = 360.0 / totalNicks";
_degreespernick = 360.0/(double)_totalnicks;
 //BA.debugLineNum = 50;BA.debugLine="Dim centerDegree As Int";
_centerdegree = 0;
 //BA.debugLineNum = 51;BA.debugLine="centerDegree = 40 ' the one in the top center (12 o'clock)";
_centerdegree = (int)(40);
 //BA.debugLineNum = 52;BA.debugLine="Dim minDegrees As Int";
_mindegrees = 0;
 //BA.debugLineNum = 53;BA.debugLine="minDegrees = -30";
_mindegrees = (int)(-30);
 //BA.debugLineNum = 54;BA.debugLine="Dim maxDegrees As Int";
_maxdegrees = 0;
 //BA.debugLineNum = 55;BA.debugLine="maxDegrees = 110";
_maxdegrees = (int)(110);
 //BA.debugLineNum = 58;BA.debugLine="Dim handInitialized As Boolean";
_handinitialized = false;
 //BA.debugLineNum = 59;BA.debugLine="Dim handPosition As Double";
_handposition = 0;
 //BA.debugLineNum = 60;BA.debugLine="handPosition = centerDegree";
_handposition = _centerdegree;
 //BA.debugLineNum = 61;BA.debugLine="Dim handTarget As Double";
_handtarget = 0;
 //BA.debugLineNum = 62;BA.debugLine="handTarget = centerDegree";
_handtarget = _centerdegree;
 //BA.debugLineNum = 63;BA.debugLine="Dim handVelocity As Double";
_handvelocity = 0;
 //BA.debugLineNum = 64;BA.debugLine="Dim handAcceleration As Double";
_handacceleration = 0;
 //BA.debugLineNum = 65;BA.debugLine="Dim lastHandMoveTime As Long";
_lasthandmovetime = 0L;
 //BA.debugLineNum = 66;BA.debugLine="lastHandMoveTime = -1";
_lasthandmovetime = (long)(-1);
 //BA.debugLineNum = 68;BA.debugLine="Dim psTemp As PhoneSensors";
mostCurrent._pstemp = new anywheresoftware.b4a.phone.Phone.PhoneSensors();
 //BA.debugLineNum = 69;BA.debugLine="Dim psFakeTemp As PhoneSensors";
mostCurrent._psfaketemp = new anywheresoftware.b4a.phone.Phone.PhoneSensors();
 //BA.debugLineNum = 70;BA.debugLine="Dim TempIsFaked As Boolean";
_tempisfaked = false;
 //BA.debugLineNum = 72;BA.debugLine="Dim scale As Float";
_scale = 0f;
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static boolean  _handneedstomove() throws Exception{
 //BA.debugLineNum = 354;BA.debugLine="Sub handNeedsToMove() As Boolean";
 //BA.debugLineNum = 355;BA.debugLine="Return Abs(handPosition - handTarget) > 0.01";
if (true) return anywheresoftware.b4a.keywords.Common.Abs(_handposition-_handtarget)>0.01;
 //BA.debugLineNum = 356;BA.debugLine="End Sub";
return false;
}
public static String  _initdrawingtools() throws Exception{
float _rimsize = 0f;
com.AB.ABExtDrawing.ABExtDrawing.ABMatrix _papermatrix = null;
double _scaleposition = 0;
com.AB.ABExtDrawing.ABExtDrawing.ABRectF _tmprect = null;
 //BA.debugLineNum = 129;BA.debugLine="Sub InitDrawingTools()";
 //BA.debugLineNum = 130;BA.debugLine="rimRect.Initialize(0.1, 0.1, 0.9, 0.9)";
mostCurrent._rimrect.Initialize((float)(0.1),(float)(0.1),(float)(0.9),(float)(0.9));
 //BA.debugLineNum = 133;BA.debugLine="rimPaint.Initialize";
mostCurrent._rimpaint.Initialize();
 //BA.debugLineNum = 134;BA.debugLine="rimPaint.SetFlags(rimPaint.flag_ANTI_ALIAS_FLAG)";
mostCurrent._rimpaint.SetFlags(mostCurrent._rimpaint.flag_ANTI_ALIAS_FLAG);
 //BA.debugLineNum = 135;BA.debugLine="rimPaint.SetLinearGradient2(1,0.40, 0.0, 0.60, 1.0, Colors.RGB(0xf0, 0xf5, 0xf0),Colors.RGB(0x30, 0x31, 0x30),rimPaint.ShaderTileMode_CLAMP)";
mostCurrent._rimpaint.SetLinearGradient2((int)(1),(float)(0.40),(float)(0.0),(float)(0.60),(float)(1.0),anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(0xf0),(int)(0xf5),(int)(0xf0)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(0x30),(int)(0x31),(int)(0x30)),mostCurrent._rimpaint.ShaderTileMode_CLAMP);
 //BA.debugLineNum = 136;BA.debugLine="rimPaint.DoShaderSingle(1)";
mostCurrent._rimpaint.DoShaderSingle((int)(1));
 //BA.debugLineNum = 138;BA.debugLine="rimCirclePaint.Initialize";
mostCurrent._rimcirclepaint.Initialize();
 //BA.debugLineNum = 139;BA.debugLine="rimCirclePaint.SetAntiAlias(True)";
mostCurrent._rimcirclepaint.SetAntiAlias(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 140;BA.debugLine="rimCirclePaint.SetStyle(rimCirclePaint.Style_STROKE)";
mostCurrent._rimcirclepaint.SetStyle(mostCurrent._rimcirclepaint.Style_STROKE);
 //BA.debugLineNum = 141;BA.debugLine="rimCirclePaint.SetColor(Colors.ARGB(0x4f, 0x33, 0x36, 0x33))";
mostCurrent._rimcirclepaint.SetColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB((int)(0x4f),(int)(0x33),(int)(0x36),(int)(0x33)));
 //BA.debugLineNum = 142;BA.debugLine="rimCirclePaint.SetStrokeWidth(0.005)";
mostCurrent._rimcirclepaint.SetStrokeWidth((float)(0.005));
 //BA.debugLineNum = 144;BA.debugLine="Dim rimSize As Float";
_rimsize = 0f;
 //BA.debugLineNum = 145;BA.debugLine="rimSize = 0.02";
_rimsize = (float)(0.02);
 //BA.debugLineNum = 147;BA.debugLine="faceRect.Initialize(rimRect.left + rimSize, rimRect.top + rimSize, rimRect.right - rimSize, rimRect.bottom - rimSize)";
mostCurrent._facerect.Initialize((float)(mostCurrent._rimrect.getLeft()+_rimsize),(float)(mostCurrent._rimrect.getTop()+_rimsize),(float)(mostCurrent._rimrect.getRight()-_rimsize),(float)(mostCurrent._rimrect.getBottom()-_rimsize));
 //BA.debugLineNum = 149;BA.debugLine="faceTexture = LoadBitmap(File.DirAssets, \"plastic.jpg\")";
mostCurrent._facetexture = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"plastic.jpg");
 //BA.debugLineNum = 150;BA.debugLine="Dim paperMatrix As ABMatrix";
_papermatrix = new com.AB.ABExtDrawing.ABExtDrawing.ABMatrix();
 //BA.debugLineNum = 151;BA.debugLine="paperMatrix.Initialize";
_papermatrix.Initialize();
 //BA.debugLineNum = 152;BA.debugLine="paperMatrix.SetScale(1.0 / faceTexture.Width,1.0 / faceTexture.Height)";
_papermatrix.setScale((float)(1.0/(double)mostCurrent._facetexture.getWidth()),(float)(1.0/(double)mostCurrent._facetexture.getHeight()));
 //BA.debugLineNum = 153;BA.debugLine="facePaint.Initialize";
mostCurrent._facepaint.Initialize();
 //BA.debugLineNum = 154;BA.debugLine="facePaint.SetFilterBitmap(True)";
mostCurrent._facepaint.SetFilterBitmap(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 155;BA.debugLine="facePaint.SetStyle(facePaint.Style_FILL)";
mostCurrent._facepaint.SetStyle(mostCurrent._facepaint.Style_FILL);
 //BA.debugLineNum = 156;BA.debugLine="facePaint.SetBitmapShader(1, faceTexture, facePaint.ShaderTileMode_MIRROR, facePaint.ShaderTileMode_MIRROR)";
mostCurrent._facepaint.SetBitmapShader((int)(1),(android.graphics.Bitmap)(mostCurrent._facetexture.getObject()),mostCurrent._facepaint.ShaderTileMode_MIRROR,mostCurrent._facepaint.ShaderTileMode_MIRROR);
 //BA.debugLineNum = 157;BA.debugLine="facePaint.SetLocalMatrix(1, paperMatrix)";
mostCurrent._facepaint.SetLocalMatrix((int)(1),_papermatrix);
 //BA.debugLineNum = 158;BA.debugLine="facePaint.DoShaderSingle(1)";
mostCurrent._facepaint.DoShaderSingle((int)(1));
 //BA.debugLineNum = 160;BA.debugLine="rimShadowPaint.Initialize";
mostCurrent._rimshadowpaint.Initialize();
 //BA.debugLineNum = 161;BA.debugLine="rimShadowPaint.SetRadialGradient(1, 0.5, 0.5, (faceRect.Right - faceRect.Left) / 2.0, Array As Int(0x00000000,0x00000500,0x50000500), Array As Float(0.96,0.96,0.99), rimShadowPaint.ShaderTileMode_MIRROR)";
mostCurrent._rimshadowpaint.SetRadialGradient((int)(1),(float)(0.5),(float)(0.5),(float)((mostCurrent._facerect.getRight()-mostCurrent._facerect.getLeft())/(double)2.0),new int[]{(int)(0x00000000),(int)(0x00000500),(int)(0x50000500)},new float[]{(float)(0.96),(float)(0.96),(float)(0.99)},mostCurrent._rimshadowpaint.ShaderTileMode_MIRROR);
 //BA.debugLineNum = 162;BA.debugLine="rimShadowPaint.setStyle(facePaint.Style_FILL)";
mostCurrent._rimshadowpaint.SetStyle(mostCurrent._facepaint.Style_FILL);
 //BA.debugLineNum = 163;BA.debugLine="rimShadowPaint.DoShaderSingle(1)";
mostCurrent._rimshadowpaint.DoShaderSingle((int)(1));
 //BA.debugLineNum = 165;BA.debugLine="ScalePaint.Initialize";
mostCurrent._scalepaint.Initialize();
 //BA.debugLineNum = 166;BA.debugLine="ScalePaint.SetStyle(facePaint.Style_STROKE)";
mostCurrent._scalepaint.SetStyle(mostCurrent._facepaint.Style_STROKE);
 //BA.debugLineNum = 167;BA.debugLine="ScalePaint.SetColor(0x9f004d0f)";
mostCurrent._scalepaint.SetColor((int)(0x9f004d0f));
 //BA.debugLineNum = 168;BA.debugLine="ScalePaint.SetStrokeWidth(0.005)";
mostCurrent._scalepaint.SetStrokeWidth((float)(0.005));
 //BA.debugLineNum = 169;BA.debugLine="ScalePaint.SetAntiAlias(True)";
mostCurrent._scalepaint.SetAntiAlias(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 171;BA.debugLine="ScalePaint.SetTextSize(0.045)";
mostCurrent._scalepaint.SetTextSize((float)(0.045));
 //BA.debugLineNum = 172;BA.debugLine="ScalePaint.SetTypeface(Typeface.SANS_SERIF)";
mostCurrent._scalepaint.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.SANS_SERIF);
 //BA.debugLineNum = 173;BA.debugLine="ScalePaint.SetTextScaleX(0.8)";
mostCurrent._scalepaint.SetTextScaleX((float)(0.8));
 //BA.debugLineNum = 174;BA.debugLine="ScalePaint.SetTextAlign(ScalePaint.Align_CENTER)";
mostCurrent._scalepaint.SetTextAlign(mostCurrent._scalepaint.Align_CENTER);
 //BA.debugLineNum = 176;BA.debugLine="Dim scalePosition As Double";
_scaleposition = 0;
 //BA.debugLineNum = 177;BA.debugLine="scalePosition = 0.10";
_scaleposition = 0.10;
 //BA.debugLineNum = 178;BA.debugLine="scaleRect.Initialize(faceRect.left + scalePosition, faceRect.top + scalePosition,faceRect.right - scalePosition, faceRect.bottom - scalePosition)";
mostCurrent._scalerect.Initialize((float)(mostCurrent._facerect.getLeft()+_scaleposition),(float)(mostCurrent._facerect.getTop()+_scaleposition),(float)(mostCurrent._facerect.getRight()-_scaleposition),(float)(mostCurrent._facerect.getBottom()-_scaleposition));
 //BA.debugLineNum = 180;BA.debugLine="titlePaint.Initialize";
mostCurrent._titlepaint.Initialize();
 //BA.debugLineNum = 181;BA.debugLine="titlePaint.setColor(0xaf946109)";
mostCurrent._titlepaint.SetColor((int)(0xaf946109));
 //BA.debugLineNum = 182;BA.debugLine="titlePaint.setAntiAlias(True)";
mostCurrent._titlepaint.SetAntiAlias(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 183;BA.debugLine="titlePaint.setTypeface(Typeface.DEFAULT_BOLD)";
mostCurrent._titlepaint.setTypeface(anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD);
 //BA.debugLineNum = 184;BA.debugLine="titlePaint.setTextAlign(titlePaint.Align_CENTER)";
mostCurrent._titlepaint.SetTextAlign(mostCurrent._titlepaint.Align_CENTER);
 //BA.debugLineNum = 185;BA.debugLine="titlePaint.setTextSize(0.05)";
mostCurrent._titlepaint.SetTextSize((float)(0.05));
 //BA.debugLineNum = 186;BA.debugLine="titlePaint.setTextScaleX(0.8)";
mostCurrent._titlepaint.SetTextScaleX((float)(0.8));
 //BA.debugLineNum = 188;BA.debugLine="titlePath.Initialize";
mostCurrent._titlepath.Initialize();
 //BA.debugLineNum = 189;BA.debugLine="Dim tmpRect As ABRectF";
_tmprect = new com.AB.ABExtDrawing.ABExtDrawing.ABRectF();
 //BA.debugLineNum = 190;BA.debugLine="tmpRect.Initialize(0.24, 0.24, 0.76, 0.76)";
_tmprect.Initialize((float)(0.24),(float)(0.24),(float)(0.76),(float)(0.76));
 //BA.debugLineNum = 191;BA.debugLine="titlePath.addArc(tmpRect, -180.0, -180.0)";
mostCurrent._titlepath.addArc(_tmprect,(float)(-180.0),(float)(-180.0));
 //BA.debugLineNum = 193;BA.debugLine="logoPaint.Initialize";
mostCurrent._logopaint.Initialize();
 //BA.debugLineNum = 194;BA.debugLine="logoPaint.SetFilterBitmap(True)";
mostCurrent._logopaint.SetFilterBitmap(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 195;BA.debugLine="logo = LoadBitmap(File.DirAssets, \"logo.png\")";
mostCurrent._logo = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"logo.png");
 //BA.debugLineNum = 196;BA.debugLine="logoMatrix.Initialize";
mostCurrent._logomatrix.Initialize();
 //BA.debugLineNum = 197;BA.debugLine="logoScale = (1.0 / logo.Width) * 0.3";
_logoscale = (1.0/(double)mostCurrent._logo.getWidth())*0.3;
 //BA.debugLineNum = 198;BA.debugLine="logoMatrix.SetScale(logoScale, logoScale)";
mostCurrent._logomatrix.setScale((float)(_logoscale),(float)(_logoscale));
 //BA.debugLineNum = 200;BA.debugLine="handPaint.Initialize";
mostCurrent._handpaint.Initialize();
 //BA.debugLineNum = 201;BA.debugLine="handPaint.SetAntiAlias(True)";
mostCurrent._handpaint.SetAntiAlias(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 202;BA.debugLine="handPaint.SetColor(0xff392f2c)";
mostCurrent._handpaint.SetColor((int)(0xff392f2c));
 //BA.debugLineNum = 203;BA.debugLine="handPaint.SetShadowLayer(0.01, -0.005, -0.005, 0x7f000000)";
mostCurrent._handpaint.SetShadowLayer((float)(0.01),(float)(-0.005),(float)(-0.005),(int)(0x7f000000));
 //BA.debugLineNum = 204;BA.debugLine="handPaint.SetStyle(handPaint.Style_FILL)";
mostCurrent._handpaint.SetStyle(mostCurrent._handpaint.Style_FILL);
 //BA.debugLineNum = 206;BA.debugLine="handPath.Initialize";
mostCurrent._handpath.Initialize();
 //BA.debugLineNum = 207;BA.debugLine="handPath.moveTo(0.5, 0.5 + 0.2)";
mostCurrent._handpath.moveTo((float)(0.5),(float)(0.5+0.2));
 //BA.debugLineNum = 208;BA.debugLine="handPath.lineTo(0.5 - 0.010, 0.5 + 0.2 - 0.007)";
mostCurrent._handpath.lineTo((float)(0.5-0.010),(float)(0.5+0.2-0.007));
 //BA.debugLineNum = 209;BA.debugLine="handPath.lineTo(0.5 - 0.002, 0.5 - 0.32)";
mostCurrent._handpath.lineTo((float)(0.5-0.002),(float)(0.5-0.32));
 //BA.debugLineNum = 210;BA.debugLine="handPath.lineTo(0.5 + 0.002, 0.5 - 0.32)";
mostCurrent._handpath.lineTo((float)(0.5+0.002),(float)(0.5-0.32));
 //BA.debugLineNum = 211;BA.debugLine="handPath.lineTo(0.5 + 0.010, 0.5 + 0.2 - 0.007)";
mostCurrent._handpath.lineTo((float)(0.5+0.010),(float)(0.5+0.2-0.007));
 //BA.debugLineNum = 212;BA.debugLine="handPath.lineTo(0.5, 0.5 + 0.2)";
mostCurrent._handpath.lineTo((float)(0.5),(float)(0.5+0.2));
 //BA.debugLineNum = 213;BA.debugLine="handPath.addCircle(0.5, 0.5, 0.025, handPath.Direction_CW)";
mostCurrent._handpath.addCircle((float)(0.5),(float)(0.5),(float)(0.025),mostCurrent._handpath.Direction_CW);
 //BA.debugLineNum = 215;BA.debugLine="handScrewPaint.Initialize";
mostCurrent._handscrewpaint.Initialize();
 //BA.debugLineNum = 216;BA.debugLine="handScrewPaint.SetAntiAlias(True)";
mostCurrent._handscrewpaint.SetAntiAlias(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 217;BA.debugLine="handScrewPaint.SetColor(0xff493f3c)";
mostCurrent._handscrewpaint.SetColor((int)(0xff493f3c));
 //BA.debugLineNum = 218;BA.debugLine="handScrewPaint.SetStyle(handScrewPaint.Style_FILL)";
mostCurrent._handscrewpaint.SetStyle(mostCurrent._handscrewpaint.Style_FILL);
 //BA.debugLineNum = 220;BA.debugLine="backgroundPaint.Initialize";
mostCurrent._backgroundpaint.Initialize();
 //BA.debugLineNum = 221;BA.debugLine="backgroundPaint.SetFilterBitmap(True)";
mostCurrent._backgroundpaint.SetFilterBitmap(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 222;BA.debugLine="End Sub";
return "";
}
public static String  _movehand() throws Exception{
long _currenttime = 0L;
float _delta = 0f;
float _direction = 0f;
 //BA.debugLineNum = 358;BA.debugLine="Sub MoveHand()";
 //BA.debugLineNum = 359;BA.debugLine="If handNeedsToMove = False Then";
if (_handneedstomove()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 360;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 363;BA.debugLine="If (lastHandMoveTime <> -1) Then";
if ((_lasthandmovetime!=-1)) { 
 //BA.debugLineNum = 364;BA.debugLine="Dim currentTime As Long";
_currenttime = 0L;
 //BA.debugLineNum = 365;BA.debugLine="currentTime = DateTime.Now";
_currenttime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 366;BA.debugLine="Dim delta As Float";
_delta = 0f;
 //BA.debugLineNum = 367;BA.debugLine="delta = (currentTime - lastHandMoveTime) / 1000.0";
_delta = (float)((_currenttime-_lasthandmovetime)/(double)1000.0);
 //BA.debugLineNum = 369;BA.debugLine="Dim direction As Float";
_direction = 0f;
 //BA.debugLineNum = 370;BA.debugLine="direction = SignND(handVelocity)";
_direction = (float)(_signnd(_handvelocity));
 //BA.debugLineNum = 371;BA.debugLine="If Abs(handVelocity) < 90.0 Then";
if (anywheresoftware.b4a.keywords.Common.Abs(_handvelocity)<90.0) { 
 //BA.debugLineNum = 372;BA.debugLine="handAcceleration = 5.0 * (handTarget - handPosition)";
_handacceleration = 5.0*(_handtarget-_handposition);
 }else {
 //BA.debugLineNum = 374;BA.debugLine="handAcceleration = 0.0";
_handacceleration = 0.0;
 };
 //BA.debugLineNum = 376;BA.debugLine="handPosition = handPosition + handVelocity * delta";
_handposition = _handposition+_handvelocity*_delta;
 //BA.debugLineNum = 377;BA.debugLine="handVelocity = handVelocity + handAcceleration * delta";
_handvelocity = _handvelocity+_handacceleration*_delta;
 //BA.debugLineNum = 378;BA.debugLine="If (handTarget - handPosition) * direction < 0.01 * direction Then";
if ((_handtarget-_handposition)*_direction<0.01*_direction) { 
 //BA.debugLineNum = 379;BA.debugLine="handPosition = handTarget";
_handposition = _handtarget;
 //BA.debugLineNum = 380;BA.debugLine="handVelocity = 0.0";
_handvelocity = 0.0;
 //BA.debugLineNum = 381;BA.debugLine="handAcceleration = 0.0";
_handacceleration = 0.0;
 //BA.debugLineNum = 382;BA.debugLine="lastHandMoveTime = -1";
_lasthandmovetime = (long)(-1);
 }else {
 //BA.debugLineNum = 384;BA.debugLine="lastHandMoveTime = DateTime.Now";
_lasthandmovetime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 };
 }else {
 //BA.debugLineNum = 387;BA.debugLine="lastHandMoveTime = DateTime.Now";
_lasthandmovetime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 388;BA.debugLine="MoveHand";
_movehand();
 };
 //BA.debugLineNum = 390;BA.debugLine="End Sub";
return "";
}
public static int  _nicktodegree(int _nick) throws Exception{
int _rawdegree = 0;
int _shifteddegree = 0;
 //BA.debugLineNum = 267;BA.debugLine="Sub nickToDegree(Nick As Int) As Int";
 //BA.debugLineNum = 268;BA.debugLine="Dim rawDegree As Int";
_rawdegree = 0;
 //BA.debugLineNum = 269;BA.debugLine="If (Nick < totalNicks / 2) Then";
if ((_nick<_totalnicks/(double)2)) { 
 //BA.debugLineNum = 270;BA.debugLine="rawDegree = Nick";
_rawdegree = _nick;
 }else {
 //BA.debugLineNum = 272;BA.debugLine="rawDegree = (Nick - totalNicks) * 2";
_rawdegree = (int)((_nick-_totalnicks)*2);
 };
 //BA.debugLineNum = 275;BA.debugLine="Dim shiftedDegree As Int";
_shifteddegree = 0;
 //BA.debugLineNum = 277;BA.debugLine="shiftedDegree = rawDegree + centerDegree";
_shifteddegree = (int)(_rawdegree+_centerdegree);
 //BA.debugLineNum = 278;BA.debugLine="Return shiftedDegree";
if (true) return _shifteddegree;
 //BA.debugLineNum = 279;BA.debugLine="End Sub";
return 0;
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 6;BA.debugLine="Dim Title As String";
_title = "";
 //BA.debugLineNum = 7;BA.debugLine="Title = \"Alwaysbusy's Corner\"";
_title = "Alwaysbusy's Corner";
 //BA.debugLineNum = 8;BA.debugLine="End Sub";
return "";
}
public static String  _sensor_sensorchanged(float[] _values) throws Exception{
float _temperaturec = 0f;
float _temperaturef = 0f;
 //BA.debugLineNum = 107;BA.debugLine="Sub sensor_SensorChanged (Values() As Float)";
 //BA.debugLineNum = 108;BA.debugLine="Dim temperatureC As Float";
_temperaturec = 0f;
 //BA.debugLineNum = 109;BA.debugLine="temperatureC = Values(0)";
_temperaturec = _values[(int)(0)];
 //BA.debugLineNum = 111;BA.debugLine="Dim temperatureF As Float";
_temperaturef = 0f;
 //BA.debugLineNum = 112;BA.debugLine="temperatureF = (9.0 / 5.0) * temperatureC + 32.0";
_temperaturef = (float)((9.0/(double)5.0)*_temperaturec+32.0);
 //BA.debugLineNum = 113;BA.debugLine="setHandTarget(temperatureF)";
_sethandtarget(_temperaturef);
 //BA.debugLineNum = 114;BA.debugLine="End Sub";
return "";
}
public static String  _sethandtarget(float _temperature) throws Exception{
 //BA.debugLineNum = 402;BA.debugLine="Sub setHandTarget(temperature As Float)";
 //BA.debugLineNum = 403;BA.debugLine="If (temperature < minDegrees) Then";
if ((_temperature<_mindegrees)) { 
 //BA.debugLineNum = 404;BA.debugLine="temperature = minDegrees";
_temperature = (float)(_mindegrees);
 }else {
 //BA.debugLineNum = 406;BA.debugLine="If (temperature > maxDegrees) Then";
if ((_temperature>_maxdegrees)) { 
 //BA.debugLineNum = 407;BA.debugLine="temperature = maxDegrees";
_temperature = (float)(_maxdegrees);
 };
 };
 //BA.debugLineNum = 410;BA.debugLine="handTarget = temperature";
_handtarget = _temperature;
 //BA.debugLineNum = 411;BA.debugLine="handInitialized = True";
_handinitialized = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 412;BA.debugLine="drawMe(MyCanvas)";
_drawme(mostCurrent._mycanvas);
 //BA.debugLineNum = 413;BA.debugLine="End Sub";
return "";
}
public static int  _signnd(double _d) throws Exception{
 //BA.debugLineNum = 392;BA.debugLine="Sub SignND(d As Double) As Int";
 //BA.debugLineNum = 393;BA.debugLine="If d = 0 Then";
if (_d==0) { 
 //BA.debugLineNum = 394;BA.debugLine="Return 0";
if (true) return (int)(0);
 }else if(_d>0) { 
 //BA.debugLineNum = 396;BA.debugLine="Return 1";
if (true) return (int)(1);
 }else {
 //BA.debugLineNum = 398;BA.debugLine="Return -1";
if (true) return (int)(-1);
 };
 //BA.debugLineNum = 400;BA.debugLine="End Sub";
return 0;
}
}
